Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/main.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/main.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/main.c	(working copy)
@@ -65,6 +65,7 @@
 typedef struct update_t {
   char * memtype;
   int    op;
+  int    fast;
   char * filename;
   int    format;
 } UPDATE;
@@ -90,7 +91,6 @@
  */
 int do_cycles;   /* track erase-rewrite cycles */
 
-
 /*
  * usage message
  */
@@ -113,6 +113,9 @@
  "                             Multiple -U options are allowed, each request\n"
  "                             is performed in the order specified.\n"
  "  -n                         Do not write anything to the device.\n"
+ "  -f <w+|->                  Write only noempty pages 2 Flash or EEPROM "
+ "                             if errased before"
+ "     <v+|->                  Only verify noempty pages of Flash"
  "  -V                         Do not verify.\n"
  "  -u                         Disable safemode, default when running from a script.\n"
  "  -s                         Silent safemode operation, will not ask you if\n"
@@ -293,9 +296,9 @@
   if (percent > 100)
     percent = 100;
 
-  if (percent > last) {
+  if (percent != last) {
     last = percent;
-    update_progress (percent, t - start_time, hdr);
+  	update_progress (percent, t - start_time, hdr);
   }
 
   if (percent == 100)
@@ -322,7 +325,7 @@
     header = hdr;
   }
 
-  if (last == 0) {
+  if ((last == 0) || (percent < 100)) {
     fprintf(stderr, "\r%s | %s | %d%% %0.2fs", 
             header, hashes, percent, etime);
   }
@@ -401,9 +404,11 @@
   }
   else if (*p == 'w') {
     upd->op = DEVICE_WRITE;
+    upd->fast = FastWrite;
   }
   else if (*p == 'v') {
     upd->op = DEVICE_VERIFY;
+    upd->fast = FastVerify;
   }
   else {
     fprintf(stderr, "%s: invalid I/O mode '%c' in update specification\n",
@@ -474,7 +479,7 @@
   }
   memcpy(upd->filename, cp, fnlen);
   upd->filename[fnlen] = 0;
-
+  
   return upd;
 }
 
@@ -543,7 +548,7 @@
             progname, mem->desc);
 	  }
     report_progress(0,1,"Reading");
-    rc = avr_read(pgm, p, upd->memtype, 0, 1);
+    rc = avr_read(pgm, p, upd->memtype, 0, 1, 0);
     if (rc < 0) {
       fprintf(stderr, "%s: failed to read all of %s memory, rc=%d\n", 
               progname, mem->desc, rc);
@@ -593,8 +598,9 @@
 	  }
 
     if (!nowrite) {
+      if (upd->fast < 0) {upd->fast = FastWrite;}
       report_progress(0,1,"Writing");
-      rc = avr_write(pgm, p, upd->memtype, size, 1);
+      rc = avr_write(pgm, p, upd->memtype, size, 1, upd->fast);
       report_progress(1,1,NULL);
     }
     else {
@@ -651,7 +657,11 @@
     }
 
     report_progress (0,1,"Reading");
-    rc = avr_read(pgm, v, upd->memtype, size, 1);
+    if (upd->fast < 0) {upd->fast = FastVerify;}
+    if (upd->fast != 0)
+    	{ rc = avr_read(pgm, v, upd->memtype, size, 1, p); }
+    else
+    	{ rc = avr_read(pgm, v, upd->memtype, size, 1, NULL); }
     if (rc < 0) {
       fprintf(stderr, "%s: failed to read all of %s memory, rc=%d\n", 
               progname, mem->desc, rc);
@@ -773,7 +783,9 @@
   ovsigck       = 0;
   terminal      = 0;
   nowrite       = 0;
+  FastWrite     = -1;
   verify        = 1;        /* on by default */
+  FastVerify    = -1;
   quell_progress = 0;
   ppisetbits    = 0;
   ppiclrbits    = 0;
@@ -835,7 +847,7 @@
   /*
    * process command line arguments
    */
-  while ((ch = getopt(argc,argv,"?b:B:c:C:DeE:Fnp:P:qstU:uvVyY:")) != -1) {
+  while ((ch = getopt(argc,argv,"?b:B:c:C:DeE:Fnp:P:qstU:uvVyY:f:")) != -1) {
 
     switch (ch) {
       case 'b': /* override default programmer baud rate */
@@ -933,6 +945,33 @@
       case 'V':
         verify = 0;
         break;
+      
+      case 'f':
+      	if (strlen(optarg) > 1) {
+      		if (optarg[0] == 'w') {
+      			if (optarg[1] == '+') {FastWrite = 1;}
+      			else { if (optarg[1] == '-') {FastWrite = 0;};}
+      		}
+      		else {
+      			if (optarg[0] =='v') {
+	      			if (optarg[1] == '+') {FastVerify = 1;}
+	      			else { if (optarg[1] == '-') {FastVerify = 0;}};
+	      		};
+      		};
+      	}
+      	if (strlen(optarg) > 2) {
+      		if (optarg[2] =='w') {
+      			if (optarg[3] == '+') {FastWrite = 1;}
+      			else { if (optarg[1] == '-') {FastWrite = 0;};}
+      		}
+      		else {
+      			if (optarg[2] =='v') {
+	      			if (optarg[3] == '+') {FastVerify = 1;}
+	      			else { if (optarg[1] == '-') {FastVerify = 0;}}
+	      		};
+      		};
+      	}
+      	break;
 
       case 'y':
         do_cycles = 1;
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/pgm.h
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/pgm.h	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/pgm.h	(working copy)
@@ -67,9 +67,9 @@
   int  (*open)           (struct programmer_t * pgm, char * port);
   void (*close)          (struct programmer_t * pgm);
   int  (*paged_write)    (struct programmer_t * pgm, AVRPART * p, AVRMEM * m, 
-                          int page_size, int n_bytes);
+                          int page_size, int n_bytes, unsigned long Adress);
   int  (*paged_load)     (struct programmer_t * pgm, AVRPART * p, AVRMEM * m,
-                          int page_size, int n_bytes);
+                          int page_size, int n_bytes, unsigned long Adress);
   void (*write_setup)    (struct programmer_t * pgm, AVRPART * p, AVRMEM * m);
   int  (*write_byte)     (struct programmer_t * pgm, AVRPART * p, AVRMEM * m,
                           unsigned long addr, unsigned char value);
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/stk500.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/stk500.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/stk500.c	(working copy)
@@ -623,15 +623,15 @@
 
 
 static int stk500_paged_write(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m, 
-                              int page_size, int n_bytes)
+                              int page_size, int n_bytes, unsigned long addr)
 {
   unsigned char buf[16];
   int memtype;
-  unsigned int addr;
   int a_div;
   int block_size;
   int tries;
   unsigned int n;
+  unsigned int max_addr, low_addr;
   int flash;
 
   if (page_size == 0) {
@@ -677,10 +677,12 @@
           n_bytes, n, a_div, page_size);
 #endif     
 
-  for (addr = 0; addr < n; addr += page_size) {
-    report_progress (addr, n_bytes, NULL);
+  low_addr = addr;
+  max_addr = addr + n;
+  for (addr = addr; addr < max_addr; addr += page_size) {
+    report_progress (addr - low_addr, n_bytes, NULL);
     
-	if (addr + page_size > n_bytes) {
+	if (addr + page_size > max_addr) {
 	   block_size = n_bytes % page_size;
 	}
 	else {
@@ -736,7 +738,7 @@
     }
   }
 
-  return n_bytes;
+  return addr;
 }
 
 static int stk500_is_page_empty(unsigned int address, int page_size, 
@@ -755,14 +757,14 @@
 }
 
 static int stk500_paged_load(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m, 
-                             int page_size, int n_bytes)
+                             int page_size, int n_bytes, unsigned long addr)
 {
   unsigned char buf[16];
   int memtype;
-  unsigned int addr;
   int a_div;
   int tries;
   unsigned int n;
+  unsigned int max_addr, low_addr;
   int block_size;
 
   if (strcmp(m->desc, "flash") == 0) {
@@ -793,10 +795,12 @@
     }
   }
 
-  for (addr = 0; addr < n; addr += page_size) {
-    report_progress (addr, n_bytes, NULL);
+  low_addr = addr;
+  max_addr = addr + n;
+  for (addr = addr; addr < max_addr; addr += page_size) {
+    report_progress (addr - low_addr, n_bytes, NULL);
 
-	if (addr + page_size > n_bytes) {
+	if (addr + page_size > max_addr) {
 	   block_size = n_bytes % page_size;
 	}
 	else {
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/stk500v2.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/stk500v2.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/stk500v2.c	(working copy)
@@ -493,9 +493,10 @@
 
 
 static int stk500v2_paged_write(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m, 
-                              int page_size, int n_bytes)
+                              int page_size, int n_bytes, unsigned long addr)
 {
-  int addr, block_size, last_addr;
+  int block_size, last_addr;
+  unsigned long max_addr, low_addr;
   int a_div=1;
   unsigned char commandbuf[10];
   unsigned char buf[266];
@@ -574,11 +575,13 @@
 
   last_addr=-1;
 
-  for (addr=0; addr < n_bytes; addr += page_size) {
-    report_progress(addr,n_bytes,NULL);
+  low_addr = addr;
+  max_addr = addr + n_bytes;
+  for (addr=addr; addr < max_addr; addr += page_size) {
+    report_progress(addr -low_addr,n_bytes,NULL);
 
-    if ((n_bytes-addr) < page_size)
-      block_size = n_bytes - addr;
+    if ((max_addr-addr) < page_size)
+      block_size = max_addr - addr;
     else
       block_size = page_size;
 
@@ -610,7 +613,7 @@
     }
   }
 
-  return n_bytes;
+  return last_addr;
 }
 
 static int stk500v2_is_page_empty(unsigned int address, int page_size,
@@ -629,12 +632,13 @@
 }
 
 static int stk500v2_paged_load(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m,
-                             int page_size, int n_bytes)
+                             int page_size, int n_bytes, unsigned long addr)
 {
-  int addr, block_size;
+  int block_size;
   unsigned char commandbuf[4];
   unsigned char buf[275];	// max buffer size for stk500v2 at this point
   unsigned char cmds[4];
+  unsigned long max_addr, low_addr;
   int result;
   OPCODE * rop;
 
@@ -664,11 +668,13 @@
 
   stk500v2_loadaddr(pgm, 0);
 
-  for (addr=0; addr < n_bytes; addr += page_size) {
-    report_progress(addr, n_bytes,NULL);
+  low_addr = addr;
+  max_addr = addr + n_bytes;
+  for (addr=addr; addr < max_addr; addr += page_size) {
+    report_progress(addr - low_addr, n_bytes,NULL);
 
-    if ((n_bytes-addr) < page_size)
-      block_size = n_bytes - addr;
+    if ((max_addr-addr) < page_size)
+      block_size = max_addr - addr;
     else
       block_size = page_size;
     DEBUG("block_size at addr %d is %d\n",addr,block_size);
@@ -694,7 +700,7 @@
     memcpy(&m->buf[addr], &buf[2], block_size);
   }
 
-  return n_bytes;
+  return addr;
 }
 
 
